Index: trunk/tools/documentation/plotting/gallery.html
===================================================================
--- trunk/tools/documentation/plotting/gallery.html	(revision 2129)
+++ trunk/tools/documentation/plotting/gallery.html	(revision 2700)
@@ -54,4 +54,5 @@
       <A HREF="topo_geogrid.html"><IMG SRC="figs/geo_domain.png" ALT="topography WRF's geogrid" STYLE="float:left;width:200px;height:200px" TARGET="value"></IMG></A>
       <A HREF="topo_geogrid_boxes.html"><IMG SRC="figs/domain_boxes.png" ALT="nested topography WRF's geogrid with boxes" STYLE="float:left;width:200px;height:200px" TARGET="value"></IMG></A>
+      <A HREF="topofix_geogrid_boxes.html"><IMG SRC="figs/plot_topofix_geogrid.png" ALT="nested fixed-topography WRF's geogrid with boxes" STYLE="float:left;width:200px;height:200px" TARGET="value"></IMG></A>
       <A HREF="trajectories.html"><IMG SRC="figs/trajectories.png" ALT="trajectories" STYLE="float:left;width:200px;height:200px" TARGET="value"></IMG></A>
       <A HREF="vals_trajectories.html"><IMG SRC="figs/val_trajectories_maxcircle_wss.png" ALT="values along a trajectory" STYLE="float:left;width:200px;height:200px" TARGET="value"></IMG></A>
Index: trunk/tools/documentation/plotting/intro.html
===================================================================
--- trunk/tools/documentation/plotting/intro.html	(revision 2129)
+++ trunk/tools/documentation/plotting/intro.html	(revision 2700)
@@ -74,4 +74,5 @@
        <LI><SPAN CLASS="codetxt">draw_topo_geogrid:</SPAN> plotting geo_em.d[nn].nc topography from WPS files </LI>
        <LI><SPAN CLASS="codetxt">draw_topo_geogrid_boxes:</SPAN> plotting different geo_em.d[nn].nc topography from WPS files </LI>
+       <LI><SPAN CLASS="codetxt">draw_topofix_geogrid_boxes:</SPAN> plotting different geo_em.d[nn].nc topography from WPS files with fixed color ranges </LI>
        <LI><SPAN CLASS="codetxt">draw_trajectories:</SPAN> Function to draw different trajectories at the same time </LI>
        <LI><SPAN CLASS="codetxt">draw_vals_trajectories:</SPAN> Function to draw values from the outputs from 'compute_tevolboxtraj' </LI>
Index: trunk/tools/documentation/plotting/plotting.html
===================================================================
--- trunk/tools/documentation/plotting/plotting.html	(revision 2129)
+++ trunk/tools/documentation/plotting/plotting.html	(revision 2700)
@@ -43,4 +43,5 @@
       <A CLASS="lc" HREF="topo_geogrid.html" TARGET="value">topo geogrid</A><BR>
       <A CLASS="lc" HREF="topo_geogrid_boxes.html" TARGET="value">topo geogrid boxes</A><BR>
+      <A CLASS="lc" HREF="topofix_geogrid_boxes.html" TARGET="value">topofix geogrid boxes</A><BR>
       <A CLASS="lc" HREF="trajectories.html" TARGET="value">trajectories</A><BR>
       <A CLASS="lc" HREF="vals_trajectories.html" TARGET="value">trajectories vals</A><BR>
Index: trunk/tools/documentation/plotting/topofix_geogrid_boxes.html
===================================================================
--- trunk/tools/documentation/plotting/topofix_geogrid_boxes.html	(revision 2700)
+++ trunk/tools/documentation/plotting/topofix_geogrid_boxes.html	(revision 2700)
@@ -0,0 +1,79 @@
+<HTML>
+  <HEAD>
+    <META HTTP-EQUIV="Content-Type" CONTENT="text/html; CHARSET=utf-8"/>
+    <LINK REL="stylesheet" TYPE="text/css" HREF="../PyNCplot.css"/>
+  </HEAD>
+
+  </HEAD>
+  <BODY>
+    <DIV CLASS="valheader">
+      draw topofix geogrid boxes
+    </DIV>
+    <DIV CLASS="valimg">
+      plotting different geo_em.d[nn].nc topography from WPS files on a fixed low-level enhanced color mode
+      <IMG WIDTH="100%" SRC="figs/plot_topofix_geogrid.png"></IMG>
+    </DIV>
+    <DIV CLASS="valhelp">
+    draw_topofix_geogrid_boxes(ncfiles, values)
+    """ plotting different geo_em.d[nn].nc topography from WPS files<BR>
+    draw_topo_geogrid_boxes(ncfiles, values) on a fixed low-level enhanced color mode<BR>
+    &nbsp;&nbsp;ncfiles= ',' list of geo_em.d[nn].nc files to use (first as topographyc <BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;reference)<BR>
+    &nbsp;&nbsp;values= [lonlatL]:[title]:[graphic_kind]:[mapvalues]:[labels]:[legvals]:<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[boxlvals]:[ColorLeg]:[mervals]:[parvals]:[coastlvals]:[countrylvals]:<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[stslvals]:[close]<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;lonlatL: limits of longitudes and latitudes [lonmin, latmin, lonmax, latmax] <BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;or None<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;title: title of the graph ('!' for spaces)<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;graphic_kind: kind of figure (jpg, pdf, png)<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;mapvalues: map characteristics [proj],[res]<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;see full documentation: http://matplotlib.org/basemap/<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[proj]: projection<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;* 'cyl', cilindric<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;* 'lcc', lambert conformal<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[res]: resolution:<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;* 'c', crude<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;* 'l', low<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;* 'i', intermediate<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;* 'h', high<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;* 'f', full<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;legvals: [locleg]|[fontsize]|[Ncol]: <BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[locleg]: location of the legend (0, automatic)<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;1: 'upper right', 2: 'upper left', 3: 'lower left', 4: 'lower right',<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;5: 'right', 6: 'center left', 7: 'center right', 8: 'lower center',<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;9: 'upper center', 10: 'center'<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[fontsize]: font size for the legend (auto for 12)<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[Ncol]: number of columns (1)<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;labels: labels to write in the graph ('!' for spaces)<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;boxlvals: [line style]|[line width] values for the boxes (['-', 3], auto)<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;ColorLeg: [ijstart, orientation, labsize, sqsize, labrotation, <BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;totboxlength, ibox, seacolor] values for the legend of colors of the <BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;topography ([0.95, 'vertical', 10., 10., 0., 0.8, 0.85, '#CCCCFF'], default)<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;ijstart: initial position as fraction of figure on the oposite axis of <BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;orientation<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;orientation: orientation of the legend<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;labsize: font size of the labels<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;sqsize: size of the squares of the legend<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;labrotation: rotation of the labels of the legend<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;totboxlength: total length of the color legend as percentage of the figure <BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; size along the given orientation<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;ibox: starting at the given orientation as percentage of the figure<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;seacolor: color for the sea<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;mervals: [fontsize]|[color line]|[labels rotation]|[line width] values for <BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;the meridians  ([8,'#AAAAAA', 0, 0.5], auto)<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;parvals: [fontsize]|[color line]|[labels rotation]|[line width] values for <BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;the parallels ([8,'#AAAAAA', 0, 0.5], auto)<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;coastlvals: [line width|color line] values for the coastline (None for any, <BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[0.25,'#161616'], auto)<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;countrylvals: [line width|color line] values for the countries (None for any,<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[0.25, '#161616'], auto)<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;stslvals: [line width|color line] values for the states (None for any, None,<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[0.25, '#080808'], auto) <BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;close: Whether figure should be finished or not<BR>
+    </DIV>
+    <DIV CLASS="valins">
+      $ python ${pyHOME}/drawing.py -o draw_topofix_geogrid_boxes -f geo_em.d01.nc,geo_em.d02.nc -S 'None:RELAMPAGO!explicit!convection!configuration:pdf:cyl,i:d01$_{8k}$,d02$_{1.6k}$:0|10|1:auto:0.17|horizontal|8|10|-45.|0.8|0.15|#CCCCFF:auto:auto:auto:auto:auto:True'
+    </DIV>
+  </BODY>
+</HTML>
+